﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MTGRenamer
{
    public class Set
    {
        #region Properties
        private string _GathererName;
        public string GathererName
        {
            get
            {
                return _GathererName.Replace("\"", "");
            }
            set
            {
                _GathererName = value;
            }
        }

        private string _WagicID;
        public string WagicID
        {
            get
            {
                if (string.IsNullOrEmpty(_WagicID))
                {
                    Set set = SetsList.GetSet(GathererName);
                    _WagicID = set != null ? set.WagicID : string.Empty;
                }
                return _WagicID;
            }
            set
            {
                _WagicID = value;
            }
        }

        private string _MagicAlbum;
        public string MagicAlbum
        {
            get
            {
                if (string.IsNullOrEmpty(_MagicAlbum))
                {
                    Set set = SetsList.GetSet(GathererName);
                    _MagicAlbum = set != null ? set.MagicAlbum : string.Empty;
                }
                return _MagicAlbum;
            }
            set
            {
                _MagicAlbum = value;
            }
        }

        private string _MagicCardsInfo;
        public string MagicCardsInfo
        {
            get
            {
                if (string.IsNullOrEmpty(_MagicCardsInfo))
                {
                    Set set = SetsList.GetSet(GathererName);
                    _MagicCardsInfo = set != null ? set.MagicCardsInfo : string.Empty;
                }
                return _MagicCardsInfo;
            }
            set
            {
                _MagicCardsInfo = value;
            }
        }

        private string _WorkstationID;
        public string WorkstationID
        {
            get
            {
                if (string.IsNullOrEmpty(_WorkstationID))
                {
                    Set set = SetsList.GetSet(GathererName);
                    _WorkstationID = set != null ? set.WorkstationID : string.Empty;
                }
                return _WorkstationID;
            }
            set
            {
                _WorkstationID = value;
            }
        }

        public bool IsInDB
        {
            get
            {
                return SetsList.Sets.Exists(x => x == this);
            }
        }
        #endregion

        #region Constructor
        public Set(string gathererName, string abbreviation, string magicAlbum, string WorkstationID, string MagicCardsInfo)
        {
            GathererName = gathererName;
            _WagicID = abbreviation;
            _MagicAlbum = magicAlbum;
            _WorkstationID = string.IsNullOrEmpty(WorkstationID) ? abbreviation : WorkstationID;
            _MagicCardsInfo = string.IsNullOrEmpty(MagicCardsInfo) ? _WorkstationID : MagicCardsInfo;
        }

        public Set(string gathererName, string abbreviation, string magicAlbum, string WorkstationID)
            : this(gathererName, abbreviation, magicAlbum, WorkstationID, String.Empty)
        {
        }

        public Set(string gathererName)
        {
            GathererName = gathererName;
        }
        #endregion

        #region Operator Overload
        public static bool operator ==(Set a, Set b)
        {
            // If both are null, or both are same instance, return true.
            if (System.Object.ReferenceEquals(a, b))
                return true;

            // If one is null, but not both, return false.
            if (((object)a == null) || ((object)b == null))
                return false;

            // Return true if the fields match:
            return a.GathererName.ToLower() == b.GathererName.ToLower();
        }

        public static bool operator !=(Set a, Set b)
        {
            return !(a == b);
        }

        public override bool Equals(Object obj)
        {
            return this == obj as Set;
        }

        public override int GetHashCode()
        {
            return base.GetHashCode();
        } 
        #endregion
    }
}
