﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.IO;
using System.Net;
using System.Text.RegularExpressions;
using Ionic.Zip;
using FuzzyStrings;
using System.Reflection;

namespace MTGRenamer
{
    public class ApprenticeDeck : Deck
    {
        #region Properties
        public static string defaultExtension = "dec";
        protected override string DefaultExtension
        {
            get
            {
                return defaultExtension;
            }
        }

        public override Deck.Types DeckType
        {
            get
            {
                return Types.Apprentice;
            }
        }
        #endregion

        #region Constructors
        public ApprenticeDeck(Deck source)
            : base(source)
        {
        }
        public ApprenticeDeck(string path)
            : base(path)
        {
        }
        #endregion

        #region Methods
        protected override void LoadFormat(string line, out string name, out string SetID, out string QtyString, out bool SideBoard)
        {
            //    4 [CFX] Path to Exile
            Regex reg = new Regex(@"^[^\d]*(?<Qty>\d*)(?<name>.*)");
            SideBoard = line.Trim().ToUpper().StartsWith("SB:");
            name = reg.Match(line).Groups["name"].Value.Trim();
            SetID = string.Empty;
            QtyString = reg.Match(line).Groups["Qty"].Value.Trim();
        }


        protected override void SaveFormat(ref StringBuilder sb, DeckCard card)
        {
            //Full Name Format
            string Prefix = card.IsSideboard ? "SB: " : "    ";
            sb.AppendFormat("{0}{1} {2}", Prefix, card.Quantity.ToString(), card.Name).AppendLine();
        }
        #endregion
    }
}
