﻿using System;
using System.Collections.Generic;
using System.Linq;
using FuzzyStrings;

namespace MTGRenamer
{
    public class DeckCard : Card
    {
        public int Quantity { get; set; }
        public bool IsSideboard { get; set; }

        public string SetName
        {
            get
            {
                return Set.GathererName;
            }
        }

        public DeckCard(Card card, int quantity, bool Sideboard = false)
            : base(card)
        {
            Quantity = quantity;
            IsSideboard = Sideboard;
        }

        public List<Card> FindAlternativeCards()
        {
            List<Card> Matches = new List<Card>();

            //IEnumerable<Card> CardToCheck = this.Set.IsInDB ? Database.Cards.Where(x => this.Set == x.Set) : Database.Cards;
            if (!this.Type.ToLower().Contains("basic land"))
            {

                foreach (Card item in Database.Cards)
                {
                    int res = Name.LevenshteinDistance(item.Name);
                    if (res > 0 && res <= 2)
                        Matches.Add(item);
                }

                Matches.AddRange(Database.Cards.Where(x => x.Name.StartsWith(Name)));
            } else
            {
                //When the card is a Land only Show Zendikar Full Art Lands
                Matches = (from i in Database.Cards
                           where i.Name.ToLower() == this.Name.ToLower() && i.Set.GathererName.ToLower() == "zendikar" && int.Parse(i.AltArt)<=4
                           select i).ToList();
            }

            Matches.Remove(this);

            return Matches;
        }
    }
}
