﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using System.Drawing;
using System.IO;

namespace MTGRenamer
{
    public static class Utils
    {
        public enum LocationType
        {
            MagicAlbum,
            Wagic,
            MagicWorkstation
        }

        #region Get Icon & Title
        public static string GetTitle()
        {
            Assembly ass = Assembly.GetExecutingAssembly();
            var name = ass.GetName();
            String Version = "v" + ass.GetName().Version.Major + ".";
            Version += ass.GetName().Version.Minor;
            if (ass.GetName().Version.Build > 0)
            {
                Version += "." + ass.GetName().Version.Build;
            }

            // assembly title attribute
            String Title = ((AssemblyTitleAttribute)ass.GetCustomAttributes(
            typeof(AssemblyTitleAttribute), false)[0]).Title;

            //#if DRM
            //            Title += " (DRM Removal)";
            //#endif

            return Title + " " + Version;
        }

        public static Icon GetIcon()
        {
            string str = new AssemblyName(Assembly.GetExecutingAssembly().FullName).Name;
            return new Icon(Assembly.GetExecutingAssembly().GetManifestResourceStream(str + ".His name is Willie.ico"));
        }
        #endregion

        //public static List<string> ReadFile(string path)
        //{
        //    if (File.Exists(path))
        //    {
        //        List<string> File = new List<string>();
        //        try
        //        {
        //            using (TextReader read = new StreamReader(path))
        //            {
        //                string line;
        //                while ((line = read.ReadLine()) != null)
        //                {
        //                    File.Add(line);
        //                }
        //            }

        //            return File;
        //        } catch (Exception e)
        //        {
        //            throw e;
        //        }
        //    }

        //    throw new FileNotFoundException("File not Found", path);
        //}

        public static void CopyType<T>(this T source, T destination)
        {
            Type sourceType = source.GetType();
            Type destinationType = destination.GetType();

            foreach (PropertyInfo sourceProperty in sourceType.GetProperties())
            {
                PropertyInfo destinationProperty = destinationType.GetProperty(sourceProperty.Name);
                if (destinationProperty != null && destinationProperty.CanWrite)
                {
                    destinationProperty.SetValue(destination, sourceProperty.GetValue(source, null), null);
                }
            }
        }

        public static void ForEachTwoList<T1, T2>(IEnumerable<T1> a, IEnumerable<T2> b, Action<T1, T2> action)
        {
            var f = a.GetEnumerator();
            var s = b.GetEnumerator();

            while (f.MoveNext() && s.MoveNext())
                action(f.Current, s.Current);
        }

        public static void ForEachLines(this string str, Action<string> action)
        {
            using (StringReader reader = new StringReader(str))
            {
                string line;
                while ((line = reader.ReadLine()) != null)
                {
                    action(line);
                }
            }
        }
    }
}
